﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports Microsoft.ComplexEventProcessing.Adapters
Imports System.Threading
Imports Microsoft.ComplexEventProcessing
Imports System.Diagnostics
Imports DemoConsole.Adapters


Public Class ConsoleOutputAdapter(Of TPayload)
    Inherits TypedPointOutputAdapter(Of TPayload)
    Private _config As ConsoleOutputAdapterConfig

    Public Sub New(ByVal config As ConsoleOutputAdapterConfig)
        _config = config
    End Sub

    Public Overrides Sub Start()
        CType(New Thread(AddressOf ConsumeEvents), Thread).Start()
    End Sub

    Public Overrides Sub [Resume]()
        CType(New Thread(AddressOf ConsumeEvents), Thread).Start()
    End Sub

    Private Sub ConsumeEvents()
        Dim currentEvent = Nothing

        Try
            Do
                If AdapterState.Stopping = AdapterState Then
                    Stopped()
                    Return
                End If

                ' Dequeue the event. If the dequeue fails, then the adapter state is suspended
                ' or stopping. Assume the former and call Ready() to indicate
                ' readiness to be resumed, and exit the thread.
                If DequeueOperationResult.Empty = Dequeue(currentEvent) Then
                    Ready()
                    Return
                End If

                If currentEvent.EventKind = EventKind.Insert Then
                    Console.WriteLine(_config.OutputMessageFormatString, currentEvent.Payload)
                ElseIf currentEvent.EventKind = EventKind.Cti Then
                    'do nothing
                End If

                ' Every received event needs to be released.
                ReleaseEvent(currentEvent)
            Loop
        Catch e As Exception
            Debug.WriteLine(e.ToString())
        End Try
    End Sub
End Class

