﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports Microsoft.ComplexEventProcessing.Adapters
Imports System.Timers
Imports Microsoft.ComplexEventProcessing

Namespace Adapters
    Public Class RandomPayloadPointInputAdapter
        Inherits TypedPointInputAdapter(Of EventPayload)
        Private _config As RandomPayloadConfig
        Private _timer As Timer

        Public Sub New(ByVal config As RandomPayloadConfig)
            _config = config
            _timer = New Timer(_config.SleepTime)
            _timer.AutoReset = True
            AddHandler _timer.Elapsed, AddressOf ProduceEvent
        End Sub

        Public Overrides Sub Start()
            _timer.Start()
        End Sub

        Public Overrides Sub [Resume]()
            _timer.Start()
        End Sub

        Private Sub ProduceEvent(ByVal sender As Object, ByVal e As ElapsedEventArgs)
            ' Check for the stopping state and stop if necessary.
            If AdapterState.Stopping = AdapterState Then
                _timer.Stop()
                Stopped()
                Return
            End If

            ' Since this method is called from a thread that is independend of
            ' Start() and Resume(), we need to make sure that the adapter is
            ' actually running.
            If AdapterState.Running <> AdapterState Then
                ' Throw away the current event.
                Return
            End If

            Dim currEvent As PointEvent(Of EventPayload) = CreateInsertEvent()
            If Nothing Is currEvent Then
                ' Throw away the current event.
                Return
            End If

            SetRandomEventPayload(currEvent)

            If EnqueueOperationResult.Full = Enqueue(currEvent) Then
                ReleaseEvent(currEvent)
                Ready()
                Return
            End If
        End Sub

        Private Shared _random As New Random()
        Private Sub SetRandomEventPayload(ByVal e As PointEvent(Of EventPayload))
            e.Payload = New EventPayload With {.Region = (CType(_random.Next(4), Region)).ToString(), .Value = _random.NextDouble()}
            e.StartTime = Date.Now
        End Sub
    End Class
End Namespace