﻿'INSTANT VB NOTE: This code snippet uses implicit typing. You will need to set 'Option Infer On' in the VB file or set 'Option Infer' at the project level.

Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text

Imports Microsoft.ComplexEventProcessing.Extensibility
Imports Microsoft.ComplexEventProcessing.Linq
Imports System.Linq.Expressions

''' <summary>
''' A user defined aggregate for adding up every other event in a window
''' </summary>
Public Class EveryOtherSum
    Inherits CepAggregate(Of Double, Double)
    Public Overrides Function GenerateOutput(ByVal payloads As IEnumerable(Of Double)) As Double
        Dim sum = Nothing
        Dim include = True
        For Each d In payloads
            If include Then
                sum += d
            End If
            include = Not include
        Next d
        Return sum
    End Function
End Class

Public Module UserDefinedAggregates
    <CepUserDefinedAggregate(GetType(EveryOtherSum))>
    <System.Runtime.CompilerServices.Extension()> _
    Public Function EveryOtherSum(Of TPayload)(ByVal window As CepWindow(Of TPayload), ByVal selector As Expression(Of Func(Of TPayload, Double))) As Double
        Throw CepUtility.DoNotCall()
    End Function
End Module
